#pragma once


#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include <queue>
#include <algorithm>
#include <numeric>
#include <set>
#include "mt19937ar.h"

using namespace std;



const int	W		= 32;		//	tB[h̕
const int	H		= 24;		//	tB[h̍
//const int	W		= 64;		//	tB[h̕
//const int	H		= 50;		//	tB[h̍
const int	SZ		= W*H;		//	tB[h̖ʐ
const int	Dir[]	= { +1, -W+1, -W, -W-1, -1, +W-1, +W, +W+1 };	//	
const int	DirT1[]	= { +1,   +1, -W,   -1, -1,   -1, +W,   +1 };	//	΂߈ړŋ󂢂Ă}X
const int	DirT2[]	= { +1, -W  , -W, -W  , -1, +W  , +W, +W   };	//	@V

extern const char *FileMap;
extern const char *FileEnemy;
extern const char *FilePlan;



//	
struct TOWER
{
	int		p, a, c;			//	ʒuA񐔁A
			TOWER() {};
			TOWER( int p_, int a_, int c_ ) : p(p_), a(a_), c(c_) {}
			TOWER( int x, int y, int a_, int c_ ) : p(y*W+x), a(a_), c(c_) {}
};

//	G
struct ENEMY
{
	int		p, t, l, s;			//	ʒuAoACtAx
			ENEMY() {};
			ENEMY( int p_, int t_, int l_, int s_ ) : p(p_), t(t_), l(l_), s(s_) {}
};



vector<char>	LoadField( istream &input );
vector<TOWER>	LoadTower( istream &input, int n );
vector<ENEMY>	LoadEnemy( istream &input, int n );
void			OutputTower( ostream &output, vector<TOWER> T );

vector<TOWER>	LoadPlan( int stage, vector<char> F );
vector<char>	LoadFieldFile( int stage, int random, int *w=NULL, int *h=NULL );
vector<vector<ENEMY> > LoadEnemyFile( int stage );

void			Simulate( int stage, vector<char> F, vector<TOWER> T,
						  vector<vector<ENEMY> > E, int *Lp, int *M, bool end=true, int *enemyrest=NULL );
int				GetTowerMoney( vector<TOWER> T );
vector<int>		GetEnemyCourse( vector<char> F, bool cross );
int				GetEnemyCourseLength( vector<char> F );

int				Distance2( int p, int q );